package
{
	import flash.display.BitmapData;
	import flash.display.Shape;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.text.AntiAliasType;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	import flash.ui.Mouse;
	import flash.utils.ByteArray;
	
	import org.flixel.*;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxU;
	
	public class GameState extends FlxState
	{	
		public static var canvas:FlxSprite;
		public var canvaspixels:ByteArray;
		
		public static var nhood:Vector.<Boolean>;
		
		public static const leftmargin:int=26;
		
		public static const vmargin1:int=0;
		public static const vmargin2:int=87;
		public static const vmargin3:int=188;
		
		public static var grids:Vector.<FlxSprite>;
		
		[Embed(source="data/r1.png")] public static var r1:Class;
		[Embed(source="data/r2.png")] public static var r2:Class;
		[Embed(source="data/picker.png")] public static var ImgPicker:Class;
		
		
		public var sizebuttons:Vector.<FlxButton>;
		public var brushbuttons:Vector.<FlxButton>;
		public var pickertarget:FlxSprite;
		public var picker:FlxSprite;
		public var selectedcol:int;//24 BIT!!!
		
		public function randAutomata():void
		{
			this.regenBrush();
		}
		
		override public function create():void
		{
			AutomataManager.Create(0xffff0000);
			sizebuttons = new Vector.<FlxButton>;
			brushbuttons = new Vector.<FlxButton>;
			
			picker = new FlxSprite(14,0,ImgPicker);
			this.add(picker);
			
			if (canvas==null)
			{
				canvas = new FlxSprite(leftmargin,0);
				canvas.createGraphic(FlxG.width-leftmargin,FlxG.height,0xffffffff,true);
				for (i=0;i<canvas.width;i++)
				{
					for (var j:int=0;j<canvas.height;j++)
					{
						//canvas._pixels.setPixel32(i,j,Math.random()<0.5?0xff000000:0xffffffff);
					}
				}
				canvas.resetHelpers();
				
				
				canvaspixels = canvas._pixels.getPixels(canvas._pixels.rect);				
			}
			nhood = new Vector.<Boolean>;
			for (i=0;i<9;i++)
			{
				nhood.push(false);
			}
			canvasrect = new Rectangle(0,0,canvas.width,canvas.height);
			
			this.add(canvas);
			
			
			for (var i:int=0;i<11;i++)
			{
				var s:FlxSprite = new FlxSprite(0,0);
				s.createGraphic(14,14,0xff000000,true);
				s._pixels.fillRect(new Rectangle(1,1,12,12),0xffffffff);
				s._pixels.fillRect(new Rectangle(1+6-(i+1)/7,1+6-(i+1)/7,2*(i+1)/7,2*(i+1)/7),0xff000000);
				
				
				s.resetHelpers();
				
				
				var sup:FlxSprite = new FlxSprite(0,0);
				sup.createGraphic(14,14,0xffff0000,true);
				sup._pixels.fillRect(new Rectangle(1,1,12,12),0xffffffff);
				
				sup._pixels.fillRect(new Rectangle(1+6-(i+1)/7,1+6-(i+1)/7,2*(i+1)/7,2*(i+1)/7),0xff000000);
							
				sup.resetHelpers();
				
				var b:FlxButton = new FlxButton(0,vmargin1+14*i,Selector.Make(onClickSize,i));
				b.loadGraphic(s,sup);
				this.add(b);
				sizebuttons.push(b);
			}
			
			//t=0;		
			
			pickertarget = new FlxSprite(picker.x-1+Math.random()*picker.width,picker.y-1+Math.random()*picker.height);
			pickertarget.createGraphic(3,3,0xff000000,true);
			pickertarget._pixels.setPixel32(1,1,0x00000000);
			this.add(pickertarget);
			
			
			
			grids = new Vector.<FlxSprite>;
			for (i=0;i<11;i++)
			{
				var spr:FlxSprite = new FlxSprite(leftmargin,0);
				spr.createGraphic(FlxG.width-leftmargin,FlxG.height,0x00000000,true);
				//horizontal scores first;
				for (j=0;j<spr.height;j+=Math.pow(2,i))
				{
					spr._pixels.fillRect(new Rectangle(0,j,FlxG.width,1),0xff000000);
				}
				
				
				//vertical scores next
				for (j=0;j<spr.width;j+=Math.pow(2,i))
				{
					spr._pixels.fillRect(new Rectangle(j,0,1,FlxG.height),0xff000000);
				}
				
				spr.visible=false;
				spr.resetHelpers();
				
				grids.push(spr);
				this.add(spr);
			}
			
			
			randAutomata();
			//this.onClickBrush(6);
			this.onClickSize(5);
			
			
			pickColor();
		}
			
		public var lastx:int=-1;
		public var lasty:int=-1;
		//public var t:Number;
		
			
		public function pickColor():void
		{
			selectedcol = this.picker._pixels.getPixel32(pickertarget.x+1-picker.x,pickertarget.y+1-picker.y);
			regenBrush();
		}

		override public function update():void
		{		
			//t+=FlxG.elapsed;
			
			if (FlxG.mouse.x>GameState.leftmargin)
			{
				if ( (FlxG.mouse.pressed() && (lastx!=FlxG.mouse.x || lasty!=FlxG.mouse.y)) 
					||
					FlxG.mouse.justPressed()
				)
				{
					paint(FlxG.mouse.x-leftmargin,FlxG.mouse.y);
				}
			}
			
			if (FlxG.mouse.justPressed() && this.picker.overlapsPoint(FlxG.mouse.x,FlxG.mouse.y))
			{
				this.pickertarget.x=FlxG.mouse.x-1;
				this.pickertarget.y=FlxG.mouse.y-1;
				pickColor();
			}
		
			
			lastx=FlxG.mouse.x;
			lasty=FlxG.mouse.y;
			
			super.update();
		}
		
		public function paint(px:int,py:int):void
		{
			var s:int = Math.pow(2,mySize);
			var x2:int=0;
			while (x2<=px)
				x2+=s;
			
			var x1:int=Math.max(x2-s,0);
			x2=Math.min(x2,canvas.width);
			
			var y2:int=0;
			while (y2<=py)
				y2+=s;
			var y1:int=Math.max(y2-s,0);
			y2=Math.min(y2,canvas.height);
			
			canvaspixels.position=0;
			
			for (var i:int=x1;i<x2;i++)
			{
				for (var j:int=y1;j<y2;j++)
				{
					processPixel(i,j);
				}
			}
			canvaspixels.position=0;
			canvas._pixels.setPixels(canvasrect,canvaspixels);
			GameState.canvas.resetHelpers();
			
		}
		
		public static var mySize:int=2;
		private var canvasrect:Rectangle;
		
		public function processPixel(i:int,j:int):void
		{
			//var n:uint = 1*getPixel(i,j-1) + 8*getPixel(i-1,j) + 8*8*getPixel(i,j)+8*8*8*getPixel(i+1,j)+8*8*8*8*getPixel(i,j+1);
			//trace(n);
			canvaspixels.position=4*(i+canvasrect.width*j); 			
			canvaspixels.writeUnsignedInt(selectedcol);
			//canvaspixels[i+canvas.width*j]=0xff000000;
//			canvas._pixels.setPixel32(i,j,0xff000000);
			//get information about pixels in the vicinity
		}
		
		public function onClickSize(n:int):void
		{
			for (var i:int=0;i<11;i++)
			{
				sizebuttons[i].on=i==n;
				grids[i].visible= i>2 && i==n;
			}
			mySize=n;
		}
		
		public static var myBrush:int=0;
		

		
		
		private function RGBToHex(r:uint, g:uint, b:uint):uint{
			var hex:uint = (r << 16 | g << 8 | b);
			return hex;
		}
		
		private function HexToRGB(hex:uint):Array{
			var rgb:Array = [];
			
			var r:uint = hex >> 16 & 0xFF;
			var g:uint = hex >> 8 & 0xFF;
			var b:uint = hex & 0xFF;
			
			rgb.push(r, g, b);
			return rgb;
		}
		
		
		 
		
		
		
		

		
		
		public function regenBrush():void
		{
			var hs_rgb:Array = this.HexToRGB(this.selectedcol);
			var v:Number=hs_rgb[0]/255.0;//gives value between 0 and 1
			

			AutomataManager.Create(v);
		}
	}
	
}

class Selector
{
	private var _onClick:Function;
	private var _n:int;
	
	public static function Make(f:Function,n:int):Function
	{
		var s:Selector = new Selector(f,n);
		return s.onClick;
	}
	
	public function Selector(f:Function,n:int)
	{
		_onClick=f;
		_n=n;
	}
	
	public function onClick():void
	{
		_onClick(_n);	
	}		
}